/**
 * Copyright (c) 2008 Washington University
 */
package org.nrg.xnat.util;

import java.util.Iterator;
import java.util.Map;

/**
 * Iterator over the keys of a map
 * @author Kevin A. Archie <karchie@npg.wustl.edu>
 *
 */
public class KeyIterator<K,V> implements Iterator<K> {
    private final Iterator<Map.Entry<K,V>> entryIterator;

    public KeyIterator(final Map<K,V> map) {
	this.entryIterator = map.entrySet().iterator();
    }
    
    public KeyIterator(final Iterator<Map.Entry<K,V>> entryIterator) {
	this.entryIterator = entryIterator;
    }
    
    /* (non-Javadoc)
     * @see java.util.Iterator#hasNext()
     */
    public boolean hasNext() {
	return entryIterator.hasNext();
    }

    /* (non-Javadoc)
     * @see java.util.Iterator#next()
     */
    public K next() {
	return entryIterator.next().getKey();
    }

    /* (non-Javadoc)
     * @see java.util.Iterator#remove()
     */
    public void remove() {
	entryIterator.remove();
    }

}
